leetcode 802.找到最终的安全状态

思路:拓补排序

其实这道题只要把顺序倒过来就行了,我们首先看到没有出度的反而是终端点,我们不如让它反过来成为没有入度的点是终端店,这样的话我们用度的个数来找到终端点就很容易了。

那么这样的话,题目中说若点满足所有的路径都到达终端点,那么这个点就是安全点

其实我们反过来说的话其实就是从所有的终端点出发,能不能都到达这个点,那么这个点就是满足安全点的条件的。

我们也发现了,求解这种多终点的输出路径问题,其实可以用拓补排序来做。接下来其实就是拓补排序了,用一个队列来存储路径点就可以了,最后排序即可。

复制代码
class Solution {
public:
    vector<int> eventualSafeNodes(vector<vector<int>>& graph) {
        vector<vector<int>>s(graph.size());
        vector<int>counts(graph.size(),0);
        for(int i=0;i<graph.size();i++){
            for(int j=0;j<graph[i].size();j++){
                s[graph[i][j]].push_back(i);
            }
            counts[i]+=graph[i].size();
        }
        vector<int>ans;//终端节点
        vector<int>res;
        queue<int>q;
        for(int i=0;i<graph.size();i++){
            if(counts[i]==0){
                ans.push_back(i); 
                res.push_back(i);
                q.push(i);            
            }
        }
        while(!q.empty()){
            int tmp=q.front();
            q.pop();
            for(int i=0;i<s[tmp].size();i++){
                if(--counts[s[tmp][i]]==0){
                    q.push(s[tmp][i]);
                    res.push_back(s[tmp][i]);
                }
            }
        }
        sort(res.begin(),res.end());
        return res;
        

    } 
};
相关推荐
kyle~7 分钟前
数据结构 --- 无锁队列(Lock-Free Queue)
linux·数据结构·c++·多线程·并发
Cccp.1231 小时前
【leetcode】(十四)从暴力递归到动态规划
数据结构·算法·leetcode·动态规划
旖旎夜光1 小时前
LeetCode 215: 数组中的第K个最大元素 (快速排序) —— 题解
c++·学习·算法·leetcode·力控
技术胖2 小时前
奎爷巡演 AIGC 视频教程 文档
算法
德彪稳坐倒骑驴2 小时前
Leetcode力扣刷题记录与题解
算法·leetcode·职场和发展
lzhdim8 小时前
AI的分类
人工智能·算法·机器学习·分类·数据挖掘
凤凰院凶涛QAQ11 小时前
《Java版数据结构 & 集合类剖析》Map & Set & 反射:“从哈希碰撞到红黑树转换,反射帮你扒开 HashMap 的桶数组看个究竟”
java·数据结构·算法
H.莓飛11 小时前
【数据结构】排序_OJ题(一):计数、桶与排序后的处理
java·开发语言·数据结构
w_zero_one13 小时前
算法--模拟
java·数据结构·算法
秋天的怀念_David13 小时前
算法一千零一夜 · 第十三夜 幻方,武侠世界里的数学迷宫
java·程序人生·算法